Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Events/OnHitRobot.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Events/OnHitRobot.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Events/OnHitRobot.cs	(revision 10011)
@@ -20,4 +20,7 @@
 #endregion
 
+using System;
+using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -37,13 +40,13 @@
 
     [StorableConstructor]
-    private OnHitRobot(bool deserializing) : base(deserializing) { }
-    private OnHitRobot(OnHitRobot original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected OnHitRobot(bool deserializing) : base(deserializing) { }
+    protected OnHitRobot(OnHitRobot original, Cloner cloner) : base(original, cloner) { }
 
     public OnHitRobot()
       : base("OnHitRobot", "This method is called when your robot collides with another robot.") {
-      this.Prefix = "\r\npublic void onHitRobot(HitRobotEvent e) {\r\n";
-      this.Suffix = "\r\nexecute();\r\n}\r\n";
+      Prefix = "public void onHitRobot(HitRobotEvent e) {";
+      Suffix =
+@"execute();
+}";
     }
 
@@ -52,9 +55,7 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      string result = "";
-      foreach (ISymbolicExpressionTreeNode c in children)
-        result += "\r\n" + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
-      return this.Prefix + "\r\n" + result + "\r\n" + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      string result = children.Aggregate(string.Empty, (current, c) => current + (Environment.NewLine + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees)));
+      return Prefix + result + Environment.NewLine + Suffix;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Events/OnHitWall.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Events/OnHitWall.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Events/OnHitWall.cs	(revision 10011)
@@ -20,4 +20,7 @@
 #endregion
 
+using System;
+using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -37,14 +40,13 @@
 
     [StorableConstructor]
-    private OnHitWall(bool deserializing) : base(deserializing) { }
-    private OnHitWall(OnHitWall original, Cloner cloner)
-      : base(original, cloner) {
-
-    }
+    protected OnHitWall(bool deserializing) : base(deserializing) { }
+    protected OnHitWall(OnHitWall original, Cloner cloner) : base(original, cloner) { }
 
     public OnHitWall()
       : base("OnHitWall", "This method is called when your robot collides with a wall.") {
-      this.Prefix = "\r\npublic void onHitWall(HitWallEvent e) {\r\n";
-      this.Suffix = "\r\nexecute();\r\n}\r\n";
+      Prefix = "public void onHitWall(HitWallEvent e) {";
+      Suffix =
+@"execute();
+}";
     }
 
@@ -53,9 +55,7 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      string result = "";
-      foreach (ISymbolicExpressionTreeNode c in children)
-        result += "\r\n" + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
-      return this.Prefix + "\r\n" + result + "\r\n" + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      string result = children.Aggregate(string.Empty, (current, c) => current + (Environment.NewLine + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees)));
+      return Prefix + result + Environment.NewLine + Suffix;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Events/OnScannedRobot.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Events/OnScannedRobot.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Events/OnScannedRobot.cs	(revision 10011)
@@ -20,4 +20,7 @@
 #endregion
 
+using System;
+using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -37,17 +40,17 @@
 
     [StorableConstructor]
-    private OnScannedRobot(bool deserializing) : base(deserializing) { }
-    private OnScannedRobot(OnScannedRobot original, Cloner cloner)
-      : base(original, cloner) {
-
-    }
+    protected OnScannedRobot(bool deserializing) : base(deserializing) { }
+    protected OnScannedRobot(OnScannedRobot original, Cloner cloner) : base(original, cloner) { }
 
     public OnScannedRobot()
       : base("OnScannedRobot", "This method is called when your robot sees another robot, i.e. when the robot's radar scan \"hits\" another robot.") {
-      this.Prefix = "\r\npublic void onScannedRobot(ScannedRobotEvent e) {" +
-                    "\r\ndouble absoluteBearing = getHeading() + e.getBearing();" +
-                    "\r\ndouble bearingFromGun = normalRelativeAngleDegrees(absoluteBearing - getGunHeading());" +
-                    "\r\nsetTurnGunRight(bearingFromGun);\r\n";
-      this.Suffix = "\r\nexecute();\r\n}\r\n";
+      Prefix =
+@"public void onScannedRobot(ScannedRobotEvent e) {
+double absoluteBearing = getHeading() + e.getBearing();
+double bearingFromGun = normalRelativeAngleDegrees(absoluteBearing - getGunHeading());
+setTurnGunRight(bearingFromGun);";
+      Suffix =
+@"execute();
+}";
     }
 
@@ -56,9 +59,7 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      string result = "";
-      foreach (ISymbolicExpressionTreeNode c in children)
-        result += "\r\n" + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
-      return this.Prefix + "\r\n" + result + "\r\n" + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      string result = children.Aggregate(string.Empty, (current, c) => current + (Environment.NewLine + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees)));
+      return Prefix + result + Environment.NewLine + Suffix;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Run.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Run.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Run.cs	(revision 10011)
@@ -20,4 +20,7 @@
 #endregion
 
+using System;
+using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -27,5 +30,5 @@
   [StorableClass]
   public class Run : CodeNode {
-    public override int MinimumArity { get { return 2; } }
+    public override int MinimumArity { get { return 1; } }
     public override int MaximumArity { get { return 10; } }
 
@@ -37,13 +40,16 @@
 
     [StorableConstructor]
-    private Run(bool deserializing) : base(deserializing) { }
-    private Run(Run original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected Run(bool deserializing) : base(deserializing) { }
+    protected Run(Run original, Cloner cloner) : base(original, cloner) { }
 
     public Run()
       : base("Run", "The main method in every robot.") {
-      this.Prefix = "\r\npublic void run() {\r\n\tsetAdjustGunForRobotTurn(true);\r\n\tturnRadarRightRadians(Double.POSITIVE_INFINITY);";
-      this.Suffix = "\r\nexecute();\r\n}\r\n";
+      Prefix =
+@"public void run() {
+setAdjustGunForRobotTurn(true);
+turnRadarRightRadians(Double.POSITIVE_INFINITY);";
+      Suffix =
+@"execute();
+}";
     }
 
@@ -52,9 +58,7 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      string result = "";
-      foreach (ISymbolicExpressionTreeNode c in children)
-        result += "\r\n" + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
-      return this.Prefix + "\r\n" + result + "\r\n" + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      string result = children.Aggregate(string.Empty, (current, c) => current + (Environment.NewLine + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees)));
+      return Prefix + result + Environment.NewLine + Suffix;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/BooleanTreeNode.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/BooleanTreeNode.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/BooleanTreeNode.cs	(revision 10011)
@@ -36,13 +36,11 @@
 
     [StorableConstructor]
-    private BooleanTreeNode(bool deserializing) : base(deserializing) { }
-    private BooleanTreeNode(BooleanTreeNode original, Cloner cloner)
+    protected BooleanTreeNode(bool deserializing) : base(deserializing) { }
+    protected BooleanTreeNode(BooleanTreeNode original, Cloner cloner)
       : base(original, cloner) {
-      this.value = original.value;
+      value = original.value;
     }
 
-    public BooleanTreeNode()
-      : base(new LogicalValue()) {
-    }
+    public BooleanTreeNode() : base(new LogicalValue()) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -55,5 +53,5 @@
 
     public override void ResetLocalParameters(IRandom random) {
-      value = (bool)(random.Next(0, 1) == 1);
+      value = random.Next(0, 2) == 1;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Conjunction.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Conjunction.cs	(revision 10011)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Conjunction.cs	(revision 10011)
@@ -0,0 +1,63 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.Robocode {
+  [StorableClass]
+  public class Conjunction : CodeNode {
+    public override int MinimumArity { get { return 2; } }
+    public override int MaximumArity { get { return byte.MaxValue; } }
+
+    [Storable]
+    public override string Prefix { get; set; }
+
+    [Storable]
+    public override string Suffix { get; set; }
+
+    [StorableConstructor]
+    protected Conjunction(bool deserializing) : base(deserializing) { }
+    protected Conjunction(Conjunction original, Cloner cloner) : base(original, cloner) { }
+
+    public Conjunction()
+      : base("Conjunction", "Conjunction comparator.") {
+      Prefix = "(";
+      Suffix = ")";
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new Conjunction(this, cloner);
+    }
+
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      if (children.Count() < 2)
+        throw new ArgumentException("Expected at leaset 2 children.", "children");
+
+      string result = string.Join(" && ", children.Select(c => ((CodeNode)c.Symbol).Interpret(c, c.Subtrees)));
+      return Prefix + result + Suffix;
+    }
+  }
+}
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Disjunction.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Disjunction.cs	(revision 10011)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Disjunction.cs	(revision 10011)
@@ -0,0 +1,59 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.Robocode {
+  [StorableClass]
+  public class Disjunction : CodeNode {
+    public override int MinimumArity { get { return 2; } }
+    public override int MaximumArity { get { return byte.MaxValue; } }
+
+    [Storable]
+    public override string Prefix { get; set; }
+
+    [Storable]
+    public override string Suffix { get; set; }
+
+    [StorableConstructor]
+    protected Disjunction(bool deserializing) : base(deserializing) { }
+    protected Disjunction(Disjunction original, Cloner cloner) : base(original, cloner) { }
+
+    public Disjunction()
+      : base("Disjunction", "Disjunction comparator.") {
+      Prefix = "(";
+      Suffix = ")";
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new Disjunction(this, cloner);
+    }
+
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      string result = string.Join(" || ", children.Select(c => ((CodeNode)c.Symbol).Interpret(c, c.Subtrees)));
+      return Prefix + result + Suffix;
+    }
+  }
+}
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Logical Comparators/Equal.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Logical Comparators/Equal.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Logical Comparators/Equal.cs	(revision 10011)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -26,7 +27,7 @@
 namespace HeuristicLab.Problems.Robocode {
   [StorableClass]
-  public class Equal : CodeNode {
-    public override int MinimumArity { get { return 0; } }
-    public override int MaximumArity { get { return 0; } }
+  public class Equal : CodeNode, ILogicalComparator {
+    public override int MinimumArity { get { return 2; } }
+    public override int MaximumArity { get { return 2; } }
 
     [Storable]
@@ -37,14 +38,8 @@
 
     [StorableConstructor]
-    private Equal(bool deserializing) : base(deserializing) { }
-    private Equal(Equal original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected Equal(bool deserializing) : base(deserializing) { }
+    protected Equal(Equal original, Cloner cloner) : base(original, cloner) { }
 
-    public Equal()
-      : base("Equal", "Equal comparator.") {
-      this.Prefix = "==";
-      this.Suffix = "";
-    }
+    public Equal() : base("Equal", "Equal comparator.") { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -52,6 +47,24 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      return this.Prefix + " " + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      ISymbolicExpressionTreeNode lhs = null, rhs = null;
+      var enumerator = children.GetEnumerator();
+      int childCount = 0;
+      while (enumerator.MoveNext()) {
+        childCount++;
+        switch (childCount) {
+          case 1: lhs = enumerator.Current; break;
+          case 2: rhs = enumerator.Current; break;
+          default: throw new System.Exception("Unexpected number of children. Expected 2 children.");
+        }
+      }
+      if (childCount < 2) throw new System.Exception("Unexpected number of children. Expected 2 children.");
+
+      var result = new[] {
+        ((CodeNode)lhs.Symbol).Interpret(lhs, lhs.Subtrees),
+        ((CodeNode)rhs.Symbol).Interpret(rhs, rhs.Subtrees)
+      };
+
+      return result[0] + " == " + result[1];
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Logical Comparators/GreaterThan.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Logical Comparators/GreaterThan.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Logical Comparators/GreaterThan.cs	(revision 10011)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -26,7 +27,7 @@
 namespace HeuristicLab.Problems.Robocode {
   [StorableClass]
-  public class GreaterThan : CodeNode {
-    public override int MinimumArity { get { return 0; } }
-    public override int MaximumArity { get { return 0; } }
+  public class GreaterThan : CodeNode, ILogicalComparator {
+    public override int MinimumArity { get { return 2; } }
+    public override int MaximumArity { get { return 2; } }
 
     [Storable]
@@ -37,14 +38,8 @@
 
     [StorableConstructor]
-    private GreaterThan(bool deserializing) : base(deserializing) { }
-    private GreaterThan(GreaterThan original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected GreaterThan(bool deserializing) : base(deserializing) { }
+    protected GreaterThan(GreaterThan original, Cloner cloner) : base(original, cloner) { }
 
-    public GreaterThan()
-      : base("GreaterThan", "GreaterThan comparator.") {
-      this.Prefix = ">";
-      this.Suffix = "";
-    }
+    public GreaterThan() : base("GreaterThan", "GreaterThan comparator.") { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -52,6 +47,24 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      return this.Prefix + " " + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      ISymbolicExpressionTreeNode lhs = null, rhs = null;
+      var enumerator = children.GetEnumerator();
+      int childCount = 0;
+      while (enumerator.MoveNext()) {
+        childCount++;
+        switch (childCount) {
+          case 1: lhs = enumerator.Current; break;
+          case 2: rhs = enumerator.Current; break;
+          default: throw new System.Exception("Unexpected number of children. Expected 2 children.");
+        }
+      }
+      if (childCount < 2) throw new System.Exception("Unexpected number of children. Expected 2 children.");
+
+      var result = new[] {
+        ((CodeNode)lhs.Symbol).Interpret(lhs, lhs.Subtrees),
+        ((CodeNode)rhs.Symbol).Interpret(rhs, rhs.Subtrees)
+      };
+
+      return result[0] + " > " + result[1];
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Logical Comparators/GreaterThanOrEqual.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Logical Comparators/GreaterThanOrEqual.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Logical Comparators/GreaterThanOrEqual.cs	(revision 10011)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -26,7 +27,7 @@
 namespace HeuristicLab.Problems.Robocode {
   [StorableClass]
-  public class GreaterThanOrEqual : CodeNode {
-    public override int MinimumArity { get { return 0; } }
-    public override int MaximumArity { get { return 0; } }
+  public class GreaterThanOrEqual : CodeNode, ILogicalComparator {
+    public override int MinimumArity { get { return 2; } }
+    public override int MaximumArity { get { return 2; } }
 
     [Storable]
@@ -37,14 +38,8 @@
 
     [StorableConstructor]
-    private GreaterThanOrEqual(bool deserializing) : base(deserializing) { }
-    private GreaterThanOrEqual(GreaterThanOrEqual original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected GreaterThanOrEqual(bool deserializing) : base(deserializing) { }
+    protected GreaterThanOrEqual(GreaterThanOrEqual original, Cloner cloner) : base(original, cloner) { }
 
-    public GreaterThanOrEqual()
-      : base("GreaterThanOrEqual", "GreaterThanOrEqual comparator.") {
-      this.Prefix = ">=";
-      this.Suffix = "";
-    }
+    public GreaterThanOrEqual() : base("GreaterThanOrEqual", "GreaterThanOrEqual comparator.") { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -52,6 +47,24 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      return this.Prefix + " " + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      ISymbolicExpressionTreeNode lhs = null, rhs = null;
+      var enumerator = children.GetEnumerator();
+      int childCount = 0;
+      while (enumerator.MoveNext()) {
+        childCount++;
+        switch (childCount) {
+          case 1: lhs = enumerator.Current; break;
+          case 2: rhs = enumerator.Current; break;
+          default: throw new System.Exception("Unexpected number of children. Expected 2 children.");
+        }
+      }
+      if (childCount < 2) throw new System.Exception("Unexpected number of children. Expected 2 children.");
+
+      var result = new[] {
+        ((CodeNode)lhs.Symbol).Interpret(lhs, lhs.Subtrees),
+        ((CodeNode)rhs.Symbol).Interpret(rhs, rhs.Subtrees)
+      };
+
+      return result[0] + " >= " + result[1];
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Logical Comparators/ILogicalComparator.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Logical Comparators/ILogicalComparator.cs	(revision 10011)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Logical Comparators/ILogicalComparator.cs	(revision 10011)
@@ -0,0 +1,24 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Robocode {
+  public interface ILogicalComparator { }
+}
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Logical Comparators/LessThan.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Logical Comparators/LessThan.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Logical Comparators/LessThan.cs	(revision 10011)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -26,7 +27,7 @@
 namespace HeuristicLab.Problems.Robocode {
   [StorableClass]
-  public class LessThan : CodeNode {
-    public override int MinimumArity { get { return 0; } }
-    public override int MaximumArity { get { return 0; } }
+  public class LessThan : CodeNode, ILogicalComparator {
+    public override int MinimumArity { get { return 2; } }
+    public override int MaximumArity { get { return 2; } }
 
     [Storable]
@@ -37,15 +38,8 @@
 
     [StorableConstructor]
-    private LessThan(bool deserializing) : base(deserializing) { }
-    private LessThan(LessThan original, Cloner cloner)
-      : base(original, cloner) {
+    protected LessThan(bool deserializing) : base(deserializing) { }
+    protected LessThan(LessThan original, Cloner cloner) : base(original, cloner) { }
 
-    }
-
-    public LessThan()
-      : base("LessThan", "LessThan comparator.") {
-      this.Prefix = "<";
-      this.Suffix = "";
-    }
+    public LessThan() : base("LessThan", "LessThan comparator.") { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -53,6 +47,24 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      return this.Prefix + " " + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      ISymbolicExpressionTreeNode lhs = null, rhs = null;
+      var enumerator = children.GetEnumerator();
+      int childCount = 0;
+      while (enumerator.MoveNext()) {
+        childCount++;
+        switch (childCount) {
+          case 1: lhs = enumerator.Current; break;
+          case 2: rhs = enumerator.Current; break;
+          default: throw new System.Exception("Unexpected number of children. Expected 2 children.");
+        }
+      }
+      if (childCount < 2) throw new System.Exception("Unexpected number of children. Expected 2 children.");
+
+      var result = new[] {
+        ((CodeNode)lhs.Symbol).Interpret(lhs, lhs.Subtrees),
+        ((CodeNode)rhs.Symbol).Interpret(rhs, rhs.Subtrees)
+      };
+
+      return result[0] + " < " + result[1];
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Logical Comparators/LessThanOrEqual.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Logical Comparators/LessThanOrEqual.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Logical Comparators/LessThanOrEqual.cs	(revision 10011)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -26,7 +27,7 @@
 namespace HeuristicLab.Problems.Robocode {
   [StorableClass]
-  public class LessThanOrEqual : CodeNode {
-    public override int MinimumArity { get { return 0; } }
-    public override int MaximumArity { get { return 0; } }
+  public class LessThanOrEqual : CodeNode, ILogicalComparator {
+    public override int MinimumArity { get { return 2; } }
+    public override int MaximumArity { get { return 2; } }
 
     [Storable]
@@ -37,14 +38,8 @@
 
     [StorableConstructor]
-    private LessThanOrEqual(bool deserializing) : base(deserializing) { }
-    private LessThanOrEqual(LessThanOrEqual original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected LessThanOrEqual(bool deserializing) : base(deserializing) { }
+    protected LessThanOrEqual(LessThanOrEqual original, Cloner cloner) : base(original, cloner) { }
 
-    public LessThanOrEqual()
-      : base("LessThanOrEqual", "LessThanOrEqual comparator.") {
-      this.Prefix = "<=";
-      this.Suffix = "";
-    }
+    public LessThanOrEqual() : base("LessThanOrEqual", "LessThanOrEqual comparator.") { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -52,6 +47,24 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      return this.Prefix + " " + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      ISymbolicExpressionTreeNode lhs = null, rhs = null;
+      var enumerator = children.GetEnumerator();
+      int childCount = 0;
+      while (enumerator.MoveNext()) {
+        childCount++;
+        switch (childCount) {
+          case 1: lhs = enumerator.Current; break;
+          case 2: rhs = enumerator.Current; break;
+          default: throw new System.Exception("Unexpected number of children. Expected 2 children.");
+        }
+      }
+      if (childCount < 2) throw new System.Exception("Unexpected number of children. Expected 2 children.");
+
+      var result = new[] {
+        ((CodeNode)lhs.Symbol).Interpret(lhs, lhs.Subtrees),
+        ((CodeNode)rhs.Symbol).Interpret(rhs, rhs.Subtrees)
+      };
+
+      return result[0] + " <= " + result[1];
     }
   }
